Summary: High performance and scalable event-driven servers
Name: event-driven-servers
Version: 0
Release: 1%{?dist}
License: BSD-like
URL: https://github.com/MarcJHuber/event-driven-servers
Source0: event-driven-servers.tar.gz
Source100: tac_plus-ng.service
Source101: tac_plus-ng.cfg
Patch0: event-driven-servers-soname_fix.diff
Patch1: event-driven-servers-no_rpath.diff
Patch2: event-driven-servers-shebang_fixes.diff
BuildRequires: gcc make
BuildRequires: c-ares-devel
BuildRequires: curl-devel
BuildRequires: freeradius-client-devel
BuildRequires: lksctp-tools-devel
BuildRequires: openldap-devel
BuildRequires: openssl-devel
BuildRequires: pam-devel
BuildRequires: pcre2-devel
BuildRequires: radcli-devel
BuildRequires: systemd
BuildRequires: zlib-devel
BuildRequires: /usr/bin/perl perl-devel 
BuildRequires: /usr/bin/python python-devel 

%description
This is a collection of high-performance and scalable event-driven servers.

notably tac_plus-ng, tac_plus, ftpd, tcprelay.

%package -n tac_plus-ng
Summary:  tac_plus-ng
Requires: event-driven-servers >= %{version}-%{release}

%description -n tac_plus-ng
This subpackage contains tac_plus-ng

%prep

%setup -q -n %{name}
%autopatch -p1

cp %{SOURCE100} tac_plus-ng.service
cp %{SOURCE101} tac_plus-ng.cfg

%build

# quite unusual stuff, but then look at openssl ;)

./configure \
    --with-cc=gcc \
    --prefix=%{_prefix} \
    --bindir=%{_bindir} \
    --etcdir=%{_sysconfdir} \
    --sbindir=%{_sbindir} \
    --libdir=%{_libdir} \
    --libarchdir=%{_libdir} \
    --libexecdir=%{_libexecdir}

perl -pi -e "s|^CFLAGS=.*|CFLAGS=%{optflags}|g" build/Makefile.inc*
perl -pi -e "s|-Wl,-rpath,/usr/lib64||g" build/Makefile.inc*

make

%install

make INSTALLROOT=%{buildroot} install

# move away the examples
chmod 644 %{buildroot}%{_sysconfdir}/mavis/sample/*
cp -rp %{buildroot}%{_sysconfdir}/mavis/sample doc/

install -d %{buildroot}%{_unitdir}
install -d %{buildroot}%{_sysconfdir}
install -m0644 tac_plus-ng.service %{buildroot}%{_unitdir}/tac_plus-ng.service
install -m0644 tac_plus-ng.cfg %{buildroot}%{_sysconfdir}/tac_plus-ng.cfg

# cleanup
rm -rf %{buildroot}%{_datadir}/mavis
rm -rf %{buildroot}%{_sysconfdir}/mavis

# requires old dead code (Authen::OPIE) that wants opie.h, so just drop it 
rm -f %{buildroot}%{_libdir}/mavis/mavis_tacplus_opie.pl

%preun -n tac_plus-ng
%systemd_preun tac_plus-ng.service

%post -n tac_plus-ng
%systemd_post tac_plus-ng.service

%postun -n tac_plus-ng
%systemd_postun_with_restart tac_plus-ng.service

%files
%license LICENSE
%doc doc/* CONTRIBUTING PREREQUISITES.txt README*
%{_bindir}/mavistest
%{_sbindir}/ftpd
%{_sbindir}/ldapmavis-mt
%{_sbindir}/mavisd
%{_sbindir}/pammavis
%{_sbindir}/pammavis-mt
%{_sbindir}/spawnd
%{_sbindir}/tac_plus
%{_sbindir}/tcprelay
%{_libdir}/libmavis.so*
%dir %{_libdir}/mavis
%{_libdir}/mavis/*

%files -n tac_plus-ng
%config(noreplace) %{_sysconfdir}/tac_plus-ng.cfg
%{_unitdir}/tac_plus-ng.service
%{_sbindir}/tac_plus-ng

%changelog
* Fri Mar 07 2025 Oden Eriksson <oe@nux.se> - 0-1
- first blood
